Attribute VB_Name = "modWinSockLib"
Option Explicit

Private Declare Function SetWindowLongA Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProcA Lib "user32" (ByVal wndrpcPrev As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const GWL_WNDPROC = -4

'Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
'Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function WSAAsyncSelect Lib "wsock32.dll" (ByVal s As Long, ByVal hWnd As Long, ByVal wMsg As Long, ByVal lEvent As Long) As Long
Private Declare Function WSAStartup Lib "wsock32.dll" (ByVal wVR As Long, lpWSAD As WSAdataTYPES) As Long
Private Declare Function WSACleanup Lib "wsock32.dll" () As Long
Private Declare Function gethostbyname Lib "wsock32.dll" (ByVal host_name As String) As Long
Public Declare Function bind Lib "wsock32.dll" (ByVal s As Long, addr As sockaddrTYPES, ByVal namelen As Long) As Long
Private Declare Function closesocket Lib "wsock32.dll" (ByVal s As Long) As Long
Public Declare Function htons Lib "wsock32.dll" (ByVal hostshort As Long) As Integer
Private Declare Function inet_addr Lib "wsock32.dll" (ByVal CP As String) As Long
Private Declare Function recvfrom Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal Flags As Long, from As sockaddrTYPES, fromlen As Long) As Long
Private Declare Function sendto Lib "wsock32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal Flags As Long, to_addr As sockaddrTYPES, ByVal tolen As Long) As Long
Public Declare Function socket Lib "wsock32.dll" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long

Public Const AF_INET = 2
Public Const FD_READ = &H1
'public Const INADDR_NONE = &HFFFF
'public Const INADDR_ANY = &H0
Public Const IPPROTO_UDP = 17
'public Const SOCK_STREAM = 1
Public Const SOCK_DGRAM = 2
Public Const PF_INET = 2

Public Type sockaddrTYPES
 sin_family As Integer
 sin_port As Integer
 sin_addr As Long
 sin_zero As String * 8
End Type

Public Type WSAdataTYPES
 wVersion As Integer
 wHighVersion As Integer
 szDescription As String * 257
 szSystemStatus As String * 129
 iMaxSockets As Integer
 iMaxUdpDg As Integer
 lpVendorInfo As Long
End Type
Private WSAdata As WSAdataTYPES

Public WinsockWindow As Long
Private OldWinsockWindow As Long

'Broadcast an arena message to all zones on the data server
Public Sub SendAllZones(Message As String)
Dim L As Long
For L = 1 To TotalServers
 UDPSend Server(L).Sock, Chr(0) + Chr(3) + MessagesSentCount(L) + Chr(3) + Chr(184) + Chr(11) + Chr(0) + Chr(0) + Chr(2) + Chr(0) + Message + Chr(0)
Next
End Sub

'Broadcast an arena message to one zone on the data server
'Public Sub SendZone(ServerIndex As Long, Message As String)
'UDPSend Server(ServerIndex).Sock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(3) + Chr(184) + Chr(11) + Chr(0) + Chr(0) + Chr(2) + Chr(0) + Message + Chr(0)
'End Sub

'Send a private arena message to one player only
Public Sub SendPM(ServerIndex As Long, UserID As Long, Message As String)
UDPSend Server(ServerIndex).Sock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(9) + GetStringL(UserID) + Message + Chr(0)
End Sub

'Send a chat message
Public Sub SendChat(ServerIndex As Long, Name As String, UserID As Long, Channel, Message As String)
UDPSend Server(ServerIndex).Sock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(10) + GetStringL(UserID) + Chr(Channel) + Name + "> " + Message
End Sub

'Event from WindowProc()
Public Sub OnRecv(TempSock As sockaddrTYPES, Message As String)
On Error GoTo ErrHandler
Dim ServerIndex As Long, b As Byte, I As Integer, I2 As Integer, I3 As Integer, I4 As Integer, I5 As Integer, L As Long, L2 As Long, L3 As Long, L4 As Long, L5 As Long, s As String, s2 As String, s3 As String, S4 As String, S5 As String

'## connection event
'--#### ACK
'------# user event Mid(Message, 7, 1)
'-------#### serverid from server.ini
'-----------#### groupid from server.ini
'---------------#### ScoreID from server.ini
'-------------------############################################################################################################################## name of zone
'-------------------------------------------------------------------------------------------------------------------------------------------------## port game server is on Mid(Message, 146, 2)
'---------------------------------------------------------------------------------------------------------------------------------------------------################################ biller password
ServerIndex = GetServerIndex(TempSock)
If ServerIndex = 0 Then 'The server is not logged in to our biller
 If Left(Message, 2) = Chr(0) + Chr(1) And Right(Message, 2) = Chr(1) + Chr(0) Then 'Yes, I'm a biller server
  UDPSend TempSock, Chr(0) + Chr(2) + Mid(Message, 3, 4) 'send ACK
 ElseIf Left(Message, 2) = Chr(0) + Chr(3) Then 'A Game Server wants to connect; ACK and Check Login
  AddTerminal "Connection request from " & GetIPFormat(GetStringL(TempSock.sin_addr)) & ":" & GetInteger(Mid(Message, 146, 2))
  Select Case GetProfile("RegisteredZones", TrimZero(Mid(Message, 20, 126)))
  Case "" 'unregistered zone
   If AllowNewZones Then
    s = GetProfile("Passwords", "BillingPassword")
    If TrimZero(Mid(Message, 148, 24)) = s Then
     SetProfile "RegisteredZones", TrimZero(Mid(Message, 20, 126)), s
     UDPSend TempSock, Chr(0) + Chr(4) + Mid(Message, 3, 4)
     AddTerminal TrimZero(Mid(Message, 20, 126)) + "(ServerID:" & GetLong(Mid(Message, 8, 4)) & " GroupID:" & GetLong(Mid(Message, 12, 4)) & " ScoreID:" & GetLong(Mid(Message, 16, 4)) & ") Unregistered zone: Valid biller password. Zone added and logged in"
     LoginServer TempSock, Mid(Message, 20, 126), Mid(Message, 146, 2), Mid(Message, 8, 4), Mid(Message, 12, 4), Mid(Message, 16, 4)
    Else
     UDPSend TempSock, Chr(0) + Chr(7)
     AddTerminal TrimZero(Mid(Message, 20, 126)) + "(ServerID:" & GetLong(Mid(Message, 8, 4)) & " GroupID:" & GetLong(Mid(Message, 12, 4)) & " ScoreID:" & GetLong(Mid(Message, 16, 4)) & ") Unregistered zone. Invalid biller password. Zone booted"
    End If
   Else
    UDPSend TempSock, Chr(0) + Chr(7)
    AddTerminal TrimZero(Mid(Message, 20, 126)) + "(ServerID:" & GetLong(Mid(Message, 8, 4)) & " GroupID:" & GetLong(Mid(Message, 12, 4)) & " ScoreID:" & GetLong(Mid(Message, 16, 4)) & ") Unregistered zone. New zones are blocked. Zone booted"
   End If
  Case TrimZero(Mid(Message, 148, 24)) 'Valid password
   UDPSend TempSock, Chr(0) + Chr(4) + Mid(Message, 3, 4)
   AddTerminal TrimZero(Mid(Message, 20, 126)) + "(ServerID:" & GetLong(Mid(Message, 8, 4)) & " GroupID:" & GetLong(Mid(Message, 12, 4)) & " ScoreID:" & GetLong(Mid(Message, 16, 4)) & ") Valid biller password. Zone logged in"
   LoginServer TempSock, Mid(Message, 20, 126), Mid(Message, 146, 2), Mid(Message, 8, 4), Mid(Message, 12, 4), Mid(Message, 16, 4)
  Case Else 'Invalid password
   UDPSend TempSock, Chr(0) + Chr(7)
   AddTerminal TrimZero(Mid(Message, 20, 126)) + "(ServerID:" & GetLong(Mid(Message, 8, 4)) & " GroupID:" & GetLong(Mid(Message, 12, 4)) & " ScoreID:" & GetLong(Mid(Message, 16, 4)) & ") Invalid biller password. Zone booted"
  End Select
 Else 'Nope, not what you're looking for
  UDPSend TempSock, Chr(0) + Chr(7)
 End If
Else 'The server is logged in
 Dim UserIndex As Long, UserID As Long
 Select Case Left(Message, 2)
 Case Chr(0) + Chr(3)
  'This message requires an ACK in response at LEAST
  UDPSend TempSock, Chr(0) + Chr(4) + Mid(Message, 3, 4)
  Select Case Mid(Message, 7, 1)
  Case Chr(1) 'Keep-alive, just ACK sent every 30 seconds
  Case Chr(2) 'Not supposed to happen
  Case Chr(3) 'Not supposed to happen
  Case Chr(4) 'A user entered
'-------# response from "Do you want to create new user"
'--------#### IP Mid(Message, 9, 4))
'------------################################ name Mid(Message, 13, 24)
'--------------------------------------------################################ password mid(Message, 45, 24) not used
'----------------------------------------------------------------------------#### UserID mid(message, 77, 4). Continuum's index of a user (their logged in user) would be UserID. Our index of a user (biller logged in user) would be UserIndex
'--------------------------------------------------------------------------------#### MacID mid(message, 81, 4)
'------------------------------------------------------------------------------------## TimeZoneBias Mid(Message, 85, 2) not used
   s = TrimZero(Mid(Message, 13, L_Name))
   L = GetUserDatabaseIndex(ServerIndex, s, Mid(Message, 81, L_MacID))
   If L > 0 Then 'User has a record
    s2 = s
    Do Until GetUserIndex2(ServerIndex, s2) = 0
     L2 = L2 + 1
     If L2 > L_Name - Len(s) Then
      s2 = Left(s2, Len(s2) - Len(CStr(L2))) + CStr(L2)
     Else
      s2 = s & Space(L2)
     End If
    Loop
    s3 = Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(0) + Mid(Message, 77, 4)
    s3 = s3 + FillZero(s2, L_Name) + FillZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name), LS_Name) + GetUserDatabaseRecordField(ServerIndex, L, U_Banner)
    s3 = s3 + GetUserDatabaseRecordField(ServerIndex, L, U_TotalSeconds) + GetUserDatabaseRecordField(ServerIndex, L, U_CreateDateTime)
    s3 = s3 + String(4, Chr(0)) + GetStringL(L) + String(4, Chr(0)) + GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
    UDPSend TempSock, s3
    LoginUser ServerIndex, s, Mid(Message, 81, L_MacID), Mid(Message, 9, L_IP), Mid(Message, 77, 4), L
    AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") Known User logged in: " + s
   Else 'User has never logged in to this biller
    If AllowNewUsers Then
     Select Case Mid(Message, 8, 1)
     Case Chr(0) 'Now have to ask a user if he wants to create new name
      If AskNewUsers Then 'biller has option to skip the confirmation box
       'UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(1) + Mid(Message, 77, 4) + String(186, Chr(0)) 'ask new user
       UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(1) + Mid(Message, 77, 4) 'ask new user
       AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") New User: " + s + " Waiting for confimation..."
       Exit Sub
      End If
     Case Chr(1) 'user chose "Yes" to create new profile
     End Select
     CreateUserDatabaseRecord ServerIndex, L, s, Mid(Message, 9, L_IP), Mid(Message, 81, L_MacID)
     s3 = Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(0) + Mid(Message, 77, 4)
     s3 = s3 + FillZero(s, L_Name) + FillZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name), LS_Name) + GetUserDatabaseRecordField(ServerIndex, L, U_Banner)
     s3 = s3 + GetUserDatabaseRecordField(ServerIndex, L, U_TotalSeconds) + GetUserDatabaseRecordField(ServerIndex, L, U_CreateDateTime)
     s3 = s3 + String(4, Chr(0)) + GetStringL(L) + String(4, Chr(0)) + GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
     UDPSend TempSock, s3
     AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") New User added to User Database and logged in: " + s
     LoginUser ServerIndex, s, Mid(Message, 81, L_MacID), Mid(Message, 9, L_IP), Mid(Message, 77, 4), L
    Else
     'UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(2) + Mid(Message, 77, 4) + String(186, Chr(0)) 'connection dissalowed
     UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(2) + Mid(Message, 77, 4) 'connection dissalowed
     AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") New User: " + s + " Connection disallowed"
    End If
   End If
  Case Chr(5) 'A user left zone (If his/her total score is less than 6 points, the score part isn't received)
'-------#### userid
'-------------------## totalseconds Mid(Message, 20, 2)
'---------------------############## score Mid(Message, 22, 14)
   UserIndex = GetUserIndex(ServerIndex, GetLong(Mid(Message, 8, 4)))
   If UserIndex = 0 Then Exit Sub 'player not in database because it's full
   With Server(ServerIndex).User(UserIndex)
   AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") " + .Name + " logging off"
   PutUserDatabaseRecordField ServerIndex, .UserDatabaseIndex, U_TotalSeconds, GetStringL(GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_TotalSeconds)) + GetInteger(Mid(Message, 20, 2)))
   If Len(Message) > 21 Then 'player's score is greater than 5
    PutScoreDatabaseRecord ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_ScoreIndex)), Mid(Message, 22, L_Score)
    AddTerminal "Score data updated to Score Database"
   End If
   If .ScoreSwap > "" Then
    For L = 1 To Server(ServerIndex).UserDatabaseRecords
     If GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID)) = .MacID Then
      If LCase(TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))) = LCase(.ScoreSwap) Then
       PutScoreDatabaseRecord ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_ScoreIndex)), GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
       PutScoreDatabaseRecord ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)), Mid(Message, 22, L_Score)
       AddTerminal .Name & " Swapped Score with " & .ScoreSwap
       Exit For
      End If
     End If
    Next
   End If
   End With
   LogoffUser ServerIndex, UserIndex
  Case Chr(7)
'-------#### userid
   UserID = GetLong(Mid(Message, 8, 4))
   If UserID = -1 Then ':name:messages
    SendAllZones Mid(Message, 18)
   Else '**messages
    If Server(ServerIndex).User(GetUserIndex(ServerIndex, UserID)).MessageOp Or Val(GetProfile("Misc", "ZonecastLock")) = 0 Then SendAllZones Mid(Message, 18)
   End If
  Case Chr(14), Chr(20) 'Chat messages. sent to subgame by client, then subgame sends the channel message to biller, then biller back to subgame
'-------#### userid
'-----------# chat channel
'-------------------------------------------###########################... chat channel message
   UserIndex = GetUserIndex(ServerIndex, GetLong(Mid(Message, 8, 4)))
   If UserIndex = 0 Then Exit Sub 'player not in database because it's full
   I = Asc(Mid(Message, 12, 1)) - 48 '49-57 on my channel #
   s = Server(ServerIndex).User(UserIndex).Channels + ","
   I2 = 1
   L3 = 0
   Do
    I3 = InStr(I2, s, ",")
    If I3 > 0 Then
     s2 = Mid(s, I2, I3 - I2)
     If s2 > "" Then
      L3 = L3 + 1 'count channels to check limit of 9, subgame2 has only 9 max
      If L3 = I Then 'sending message on channel #  Ex: ;#;message
       For L = 1 To TotalServers
        For L2 = 1 To Server(L).TotalUsers
         If L2 <> UserIndex Then 'don't send to self cause client already showed what sent
          s3 = Server(L).User(L2).Channels + ","
          I4 = 1
          L5 = 0
          Do
           I5 = InStr(I4, s3, ",")
           If I5 > 0 Then
            S4 = Mid(s3, I4, I5 - I4)
            If S4 > "" Then
             L5 = L5 + 1 'count channels to check limit of 9
             If s2 = S4 Then SendChat L, Server(ServerIndex).User(UserIndex).Name, Server(L).User(L2).UserID, L5, Mid(Message, 44)
            End If
            I4 = I5 + 1
           End If
          Loop Until I5 = 0 Or L5 = 9
         End If
        Next
       Next
      End If
     End If
     I2 = I3 + 1
    End If
   Loop Until I3 = 0 Or L3 = 9
  Case Chr(15): AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") [" + Server(ServerIndex).User(GetUserIndex(ServerIndex, GetLong(Mid(Message, 8, 4)))).Name + "] " + TrimZero(Mid(Message, 12))
  Case Chr(16) 'player changed banner from game then our biller received it
'-------#### userid
'-----------################################################################################################ banner (96 bytes)
   PutUserDatabaseRecordField ServerIndex, Server(ServerIndex).User(GetUserIndex(ServerIndex, GetLong(Mid(Message, 8, 4)))).UserDatabaseIndex, U_Banner, Mid(Message, 12, L_Banner)
  Case Chr(17) 'won flag game. received a score update (only when flag games are won or when user leaves zone does biller get a score update)
'-------#### userid
'-----------############## score string
   UserIndex = GetUserIndex(ServerIndex, GetLong(Mid(Message, 8, 4)))
   If UserIndex = 0 Then Exit Sub 'player not in database because it's full
   PutScoreDatabaseRecord ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, Server(ServerIndex).User(UserIndex).UserDatabaseIndex, U_ScoreIndex)), Mid(Message, 12, L_Score)
  Case Chr(19) 'Biller command
'-------#### userid
'-----------#########... command
   Dim Command As String
   Command = TrimZero(Mid(Message, 12))
   UserID = GetLong(Mid(Message, 8, 4))
   UserIndex = GetUserIndex(ServerIndex, UserID)
   If UserIndex = 0 Then Exit Sub 'player not in database because it's full
   With Server(ServerIndex).User(UserIndex)
   If Left(Command, 12) = "?squadcreate" Then
    s = LTrim(Mid(Command, 13))
    I = InStr(s, ":")
    s2 = s
    If I > 0 Then
     s2 = Left(s, I - 1)
     s3 = Mid(s, I + 1)
    End If
    L = GetSquadDatabaseIndex(ServerIndex, s2)
    If L = 0 Then
     Server(ServerIndex).SquadDatabaseRecords = Server(ServerIndex).SquadDatabaseRecords + 1
     PutSquadDatabaseRecord ServerIndex, Server(ServerIndex).SquadDatabaseRecords, FillZero(s2, LS_Name) + FillZero(s3, LS_Password) + GetStringL(.UserDatabaseIndex)
     PutUserDatabaseRecordField ServerIndex, .UserDatabaseIndex, U_SquadIndex, GetStringL(Server(ServerIndex).SquadDatabaseRecords)
     SendPM ServerIndex, UserID, "Squad successfully created and joined.  Reenter for it to take effect"
    Else
     SendPM ServerIndex, UserID, "Squad already exists"
    End If
   ElseIf Left(Command, 10) = "?squadjoin" Then
    s = LTrim(Mid(Command, 11))
    I = InStr(s, ":")
    s2 = s
    If I > 0 Then
     s2 = Left(s, I - 1)
     s3 = Mid(s, I + 1)
    End If
    L = GetSquadDatabaseIndex(ServerIndex, s2)
    If L = 0 Then
     SendPM ServerIndex, UserID, "Squad unknown in Squad Database"
    Else
     If FillZero(s3, LS_Password) = GetSquadDatabaseRecordField(ServerIndex, L, S_Password) Or GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Then
      PutUserDatabaseRecordField ServerIndex, .UserDatabaseIndex, U_SquadIndex, GetStringL(L)
      SendPM ServerIndex, UserID, "Squad successfully joined.  Reenter for it to take effect"
     Else
      SendPM ServerIndex, UserID, "Invalid squad password"
     End If
    End If
   ElseIf Command = "?squadleave" Then
    L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
    If L = 0 Then
     SendPM ServerIndex, UserID, "You are not in a squad"
    Else
     s = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
     s2 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Password))
     PutUserDatabaseRecordField ServerIndex, .UserDatabaseIndex, U_SquadIndex, String(LU_SquadIndex, Chr(0))
     SendPM ServerIndex, UserID, L & ". " & s & " " & s2 & " You left your current squad.  Reenter for it to take effect"
     If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Then
      SendPM ServerIndex, UserID, "You are still the owner"
     End If
    End If
   ElseIf Left(Command, 14) = "?squaddissolve" Then
    s = LTrim(Mid(Command, 15))
    If IsNumeric(s) Then
     L = Val(s)
     If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Then
      SendPM ServerIndex, UserID, L & ". " & TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name)) & " " & TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Password)) & " Squad dissolved.  Reenter for it to take effect"
      For L2 = 1 To Server(ServerIndex).UserDatabaseRecords
       If GetLong(GetUserDatabaseRecordField(ServerIndex, L2, U_SquadIndex)) = L Then
        PutUserDatabaseRecordField ServerIndex, L2, U_SquadIndex, String(LU_SquadIndex, Chr(0))
       End If
      Next
      With Server(ServerIndex)
      .SquadDatabase = Left(.SquadDatabase, (L - 1) * S_Length) + Mid(.SquadDatabase, L * S_Length + 1)
      .SquadDatabaseRecords = .SquadDatabaseRecords - 1
      End With
     Else
      SendPM ServerIndex, UserID, "You are not the owner of the squad"
     End If
    Else
     SendPM ServerIndex, UserID, "Format: ?squaddissolve (SquadID)"
    End If
   ElseIf Left(Command, 11) = "?squadgrant" Then
    s = Mid(Command, 12)
    If IsNumeric(s) Then
     L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
     If L = 0 Then
      SendPM ServerIndex, UserID, "You are not in a squad"
     Else
      L3 = GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex))
      If L3 = .UserDatabaseIndex Or L3 < 1 Then
       L2 = Val(s) 'you can make a squad be owned by no one
       If L2 > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
       PutSquadDatabaseRecordField ServerIndex, L, S_OwnerIndex, GetStringL(L2)
       SendPM ServerIndex, UserID, L2 & ". " & IIf(L2 < 1, "Squad ownership is lost", TrimZero(GetUserDatabaseRecordField(ServerIndex, L2, U_Name)) & " Player was made the owner of your squad")
      Else
       SendPM ServerIndex, UserID, "You are not the owner of the squad you are currently in"
      End If
     End If
    Else
     SendPM ServerIndex, UserID, "Format: ?squadgrant (UserID)"
    End If
   ElseIf Left(Command, 14) = "?squadpassword" Then
    s = Mid(Command, 15)
    I = InStr(s, ":")
    If I > 0 Then
     L = Val(Mid(s, 2, I - 1 - 1))
     s = Mid(s, I + 1)
    Else
     If IsNumeric(s) Then
      L = Val(s)
     Else
      L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
      If L = 0 Then
       SendPM ServerIndex, UserID, "You are not in a squad"
       Exit Sub
      End If
     End If
    End If
    s2 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
    If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Or .AccountOp Then
     s3 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Password))
     If I = 0 Then
      If Left(s, 1) <> " " Or Left(s, 1) <> "=" Then
       SendPM ServerIndex, UserID, L & ". Squad password is " & s3
       Exit Sub
      End If
     End If
     PutSquadDatabaseRecordField ServerIndex, L, S_Password, s
     SendPM ServerIndex, UserID, L & ". " & s2 & " " & s3 & " Squad password changed to " & s
    Else
     SendPM ServerIndex, UserID, L & ". " & s2 & " You are not the owner of the squad"
    End If
   ElseIf Left(Command, 10) = "?squadkick" Then
    L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
    If L = 0 Then
     SendPM ServerIndex, UserID, "You are not in a squad"
    Else
     If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Then
      L2 = Val(Mid(Command, 11))
      If L2 < 1 Or L2 > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
      If L = GetLong(GetUserDatabaseRecordField(ServerIndex, L2, U_SquadIndex)) Then 'user you are kicking is in your squad
       PutUserDatabaseRecordField ServerIndex, L2, U_SquadIndex, String(LU_SquadIndex, Chr(0))
       SendPM ServerIndex, UserID, L2 & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L2, U_Name)) & " Player was removed from your squad"
      Else
       SendPM ServerIndex, UserID, "Player is not in your squad."
      End If
     Else
      SendPM ServerIndex, UserID, "You are not the owner of the squad you are currently in"
     End If
    End If
   ElseIf Left(Command, 13) = "?squadmembers" Then
    s = LTrim(Mid(Command, 14))
    I = InStr(s, " ")
    If I > 0 Then
     L4 = Val(Left(s, I - 1))
     s = Mid(s, I + 1)
    End If
    If L4 = 0 Then L4 = 1
    L5 = 1
    If s = "" Then s = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex)), S_Name))
    L = GetSquadDatabaseIndex(ServerIndex, s)
    If L = 0 Then
     SendPM ServerIndex, UserID, "Squad unknown in Squad Database"
    Else
     s = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
     L3 = GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex))
     SendPM ServerIndex, UserID, "Members of squad " & s
     For L2 = 1 To Server(ServerIndex).UserDatabaseRecords
      If GetLong(GetUserDatabaseRecordField(ServerIndex, L2, U_SquadIndex)) = L Then
       b = b + 1
       If b = 40 Then L5 = L5 + 1: b = 0
       If L5 = L4 Then SendPM ServerIndex, UserID, L2 & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L2, U_Name)) + IIf(L3 = L2, " - Owner", "")
       If L5 > L4 Then Exit For
      End If
     Next
     SendPM ServerIndex, UserID, "Page " & L4
    End If
   ElseIf Command = "?squadid" Then
    L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
    If L = 0 Then
     SendPM ServerIndex, UserID, "You are not in a squad"
    Else
     SendPM ServerIndex, UserID, "SquadID:" & L
    End If
   ElseIf Command = "?scoreid" Then
    SendPM ServerIndex, UserID, "ScoreID:" & GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_ScoreIndex))
   ElseIf Left(Command, 14) = "?squaddatabase" Then
    SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).SquadDatabaseRecords))) + "  Squad Name" + Space(LS_Name - 10) + " Owner" + Space(L_Name - 5) + " Status"
    L2 = Val(Mid(Command, 15))
    If L2 = 0 Then L2 = 1
    For L = 1 + 40 * (L2 - 1) To 40 * (L2 - 1) + 40
     If L > Server(ServerIndex).SquadDatabaseRecords Then Exit For
     s2 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
     s3 = TrimZero(GetUserDatabaseRecordField(ServerIndex, GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)), U_Name))
     SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).SquadDatabaseRecords)) - Len(CStr(L))) & L & ". " & s2 + Space(LS_Name - Len(s2)) + " " + s3 + Space(L_Name - Len(s3)) + " " + IIf(TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Password)) > "", "Private", "Public")
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 11) = "?squadowner" Then
    If Not .AccountOp Then Exit Sub
    s = LTrim(Mid(Command, 12))
    I = InStr(s, ":")
    L = Val(s)
    If I > 0 Then
     L = Val(Left(s, I - 1))
    End If
    If L < 1 Or L > Server(ServerIndex).SquadDatabaseRecords Then SendPM ServerIndex, UserID, "SquadID is out of bounds": Exit Sub
    If I > 0 Then
     L2 = Val(Val(Mid(s, I + 1)))
     If L2 > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
     PutSquadDatabaseRecordField ServerIndex, L, S_OwnerIndex, GetStringL(L2)
     SendPM ServerIndex, UserID, L2 & ". " & IIf(L2 < 1, "Squad ownership is lost", TrimZero(GetUserDatabaseRecordField(ServerIndex, L2, U_Name)) & " Player was made the owner of the squad")
    Else
     L2 = GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex))
     SendPM ServerIndex, UserID, L2 & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L2, U_Name))
    End If
   ElseIf Left(Command, 9) = "?squadown" Then
    SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).SquadDatabaseRecords))) + "  Squad Name" + Space(LS_Name - 10) + " Squad Password"
    L2 = Val(Mid(Command, 10))
    If L2 = 0 Then L2 = 1
    L3 = 1
    For L = 1 To Server(ServerIndex).SquadDatabaseRecords
     If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) = .UserDatabaseIndex Then
      b = b + 1
      If b = 40 Then L3 = L3 + 1: b = 0
      If L3 = L2 Then
       s = TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
       SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).SquadDatabaseRecords)) - Len(CStr(L))) & L & ". " & s + Space(LS_Name - Len(s)) + " " + TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Password))
      End If
      If L3 > L2 Then Exit For
     End If
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 10) = "?squadname" Then
    s = LTrim(Mid(Command, 11))
    I = InStr(s, ":")
    If I > 0 Then
     L = Val(Left(s, I - 1))
    Else
     If s = "" Then
      L = GetLong(GetUserDatabaseRecordField(ServerIndex, .UserDatabaseIndex, U_SquadIndex))
     Else
      L = Val(s)
     End If
    End If
    If L < 1 Or L > Server(ServerIndex).SquadDatabaseRecords Then SendPM ServerIndex, UserID, "SquadID is out of bounds": Exit Sub
    If I = 0 Then
     SendPM ServerIndex, UserID, L & ". " & TrimZero(GetSquadDatabaseRecordField(ServerIndex, L, S_Name))
    Else
     If Not .AccountOp Then
      If GetLong(GetSquadDatabaseRecordField(ServerIndex, L, S_OwnerIndex)) <> .UserDatabaseIndex Then
       SendPM ServerIndex, UserID, "You are not the owner of the squad"
       Exit Sub
      End If
     End If
     PutSquadDatabaseRecordField ServerIndex, L, S_Name, Mid(s, I + 1)
     SendPM ServerIndex, UserID, "Squad name changed. Squad members must reenter for it to take effect"
    End If
   ElseIf Left(Command, 5) = "?chat" Then
    s = Mid(Command, 6)
    If Left(s, 1) = "=" Or Left(s, 1) = " " Then .Channels = Mid(s, 2, 128): Exit Sub 'maximum length the subgame will take
    s = .Channels & ","
    I = 1
    L3 = 0
    Do
     I2 = InStr(I, s, ",")
     If I2 > 0 Then
      s2 = Mid(s, I, I2 - I)
      If s2 > "" Then
       L3 = L3 + 1 'count channels to check limit of 9, subgame2 has only 9 max
       S5 = L3 & ":[" & s2 & "] "
       For L = 1 To TotalServers
        For L2 = 1 To Server(L).TotalUsers
         If InStr(Server(L).User(L2).Channels, s2) > 0 Then S5 = S5 & Server(L).User(L2).Name & ","
        Next
       Next
       SendPM ServerIndex, UserID, Left(S5, Len(S5) - 1)
      End If
      I = I2 + 1
     End If
    Loop Until I2 = 0 Or L3 = 9
    If L3 = 0 Then SendPM ServerIndex, UserID, "You are not on any chat channels. Type ?chat=channelname or ?chat channelname to correctly enter in a chat channel. To enter in more than 1, include a commas after channel names."
   ElseIf Left(Command, 5) = "?find" Then ''''maybe add page support
    If .SysOp Then
     s = LCase(LTrim(Mid(Command, 6)))
     For L = 1 To TotalServers
      For L2 = 1 To Server(L).TotalUsers
       s3 = GetIPFormat(GetStringL(Server(L).User(L2).IP))
       If InStr(LCase(Server(L).User(L2).Name), s) > 0 Or Val(s) = Server(L).User(L2).MacID Or InStr(s3, s) > 0 Then SendPM ServerIndex, UserID, Server(L).User(L2).Name & " (" & Server(L).User(L2).MacID & ") [" & s3 & "] - " + Server(L).Name: s2 = "1"
      Next
     Next
    Else
     s = LCase(LTrim(Mid(Command, 6, L_Name)))
     For L = 1 To TotalServers
      For L2 = 1 To Server(L).TotalUsers
       If InStr(LCase(Server(L).User(L2).Name), s) > 0 Then SendPM ServerIndex, UserID, Server(L).User(L2).Name + " - " + Server(L).Name: s2 = "1"
      Next
     Next
    End If
    If s2 = "" Then SendPM ServerIndex, UserID, "Not found on " + App.Title + " network"
   ElseIf Left(Command, 4) = "?top" Then
    s = LTrim(Mid(Command, 5))
    I = InStr(s, " ")
    L5 = Val(s)
    If I > 0 Then
     L5 = Val(Left(s, I - 1))
     s = LTrim(Mid(s, I + 1))
    End If
    SendPM ServerIndex, UserID, Space(Len(CStr(L5))) + " Name" + Space(L_Name - 4) + " Squad" + Space(LS_Name - 5) + " Win   Loss  Ratio KillPoints FlagPoints TotalPoints"
    'w L r klps fgps
    s2 = Server(ServerIndex).UserDatabase
    L2 = Server(ServerIndex).UserDatabaseRecords 'initial
    Select Case s
    'with a large database, sorting will be faster with repetitive code
    Case "win"
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetInteger(Left(S4, 2)) < GetInteger(Left(S5, 2)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    Case "loss"
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetInteger(Mid(S4, 3, 2)) < GetInteger(Mid(S5, 3, 2)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    Case "ratio"
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetInteger(Mid(S4, 5, 2)) < GetInteger(Mid(S5, 5, 2)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    Case "kill"
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetLong(Mid(S4, 7, 4)) < GetLong(Mid(S5, 7, 4)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    Case "flag"
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetLong(Mid(S4, 11, 4)) < GetLong(Mid(S5, 11, 4)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    Case Else 'totalpoints (killpoints+flagpoints)
     Do
      L3 = 0 'no indexes were swapped
      For L = 1 To L2 'swapping loop
       S4 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       S5 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
       If GetLong(Mid(S4, 7, 4)) + GetLong(Mid(S4, 11, 4)) < GetLong(Mid(S5, 7, 4)) + GetLong(Mid(S5, 11, 4)) Then
        s3 = Mid(s2, (L - 1) * U_Length + 1, U_Length)
        s2 = Left(s2, (L - 1) * U_Length) + Mid(s2, (L + 1 - 1) * U_Length + 1, U_Length) + Mid(s2, L * U_Length + 1)
        s2 = Left(s2, (L + 1 - 1) * U_Length) + s3 + Mid(s2, (L + 1) * U_Length + 1)
        L3 = L
       End If
      Next
      L2 = L3
     Loop While L3 > 1
    End Select
    L4 = L5 - 10
    If L4 < 0 Then L4 = 0
    For L = 1 + L4 To L5
     If L > Server(ServerIndex).UserDatabaseRecords Then Exit Sub
     s = TrimZero(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_Name + 1, L_Name))
     S4 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name))
     s3 = GetScoreDatabaseRecord(ServerIndex, GetLong(Mid(Mid(s2, (L - 1) * U_Length + 1, U_Length), U_ScoreIndex + 1, LU_ScoreIndex)))
     SendPM ServerIndex, UserID, Space(Len(CStr(L5)) - Len(CStr(L))) & L & " " & s & Space(L_Name - Len(s)) & " " & S4 & Space(LS_Name - Len(S4)) & " " & GetInteger(Left(s3, 2)) & Space(5 - Len(CStr(GetInteger(Left(s3, 2))))) & " " & GetInteger(Mid(s3, 3, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s3, 3, 2))))) & " " & GetInteger(Mid(s3, 5, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s3, 5, 2))))) & " " & GetLong(Mid(s3, 7, 4)) & Space(10 - Len(CStr(GetLong(Mid(s3, 7, 4))))) & " " & GetLong(Mid(s3, 11, 4)) & Space(10 - Len(CStr(GetLong(Mid(s3, 11, 4))))) & " " & (GetLong(Mid(s3, 7, 4)) + GetLong(Mid(s3, 11, 4)))
    Next
   ElseIf Left(Command, 9) = "?scoreown" Then
    SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords))) + "  Name" + Space(L_Name - 4) + " Squad" + Space(LS_Name - 5) + " Win   Loss  Ratio KillPoints FlagPoints TotalPoints"
    L2 = Val(Mid(Command, 10))
    If L2 = 0 Then L2 = 1
    L4 = 1
    For L = 1 To Server(ServerIndex).UserDatabaseRecords
     If GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID)) = .MacID Then
      b = b + 1
      If b = 40 Then L4 = L4 + 1: b = 0
      If L4 = L2 Then
       s = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
       S4 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name))
       s2 = GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
       SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords)) - Len(CStr(L))) & L & ". " & s & Space(L_Name - Len(s)) & " " & S4 & Space(LS_Name - Len(S4)) & " " & GetInteger(Left(s2, 2)) & Space(5 - Len(CStr(GetInteger(Left(s2, 2))))) & " " & GetInteger(Mid(s2, 3, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 3, 2))))) & " " & GetInteger(Mid(s2, 5, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 5, 2))))) & " " & GetLong(Mid(s2, 7, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 7, 4))))) & " " & GetLong(Mid(s2, 11, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 11, 4))))) & " " & (GetLong(Mid(s2, 7, 4)) + GetLong(Mid(s2, 11, 4)))
      End If
      If L4 > L2 Then Exit For
     End If
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 10) = "?scoreswap" Then
    s = LCase(LTrim(Mid(Command, 11)))
    If s = "" Then
     If .ScoreSwap > "" Then
      SendPM ServerIndex, UserID, "DISABLED: Score swap of " + .Name + " with " + .ScoreSwap + " on exit"
      .ScoreSwap = ""
     Else
      SendPM ServerIndex, UserID, "You must specify one of your names. Send ?scoreown for all your names."
     End If
    Else
     For L = 1 To Server(ServerIndex).UserDatabaseRecords
      If GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID)) = .MacID Then
       s2 = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
       If LCase(s2) = s Then
        SendPM ServerIndex, UserID, "ENABLED: Score swap of " + .Name + " with " + s2 + " on exit"
        .ScoreSwap = s2
        Exit Sub
       End If
      End If
     Next
     SendPM ServerIndex, UserID, "User name is not yours or unknown in User Database."
    End If
'can't do cause when player types ?userid, it will different from databases' userid
'   ElseIf Left(Command, 11) = "?useridmove" Then
'    If Not .AccountOp Then Exit Sub
'
'    s = LTrim(Mid(Command, 12))
'    If s = "" Then
'     SendPM ServerIndex, UserID, "Format: ?useridmove (UserID:new id)"
'     Exit Sub
'    End If
'    I = InStr(s, ":")
'    If I > 0 Then
'     l = Val(Left(s, I - 1)) Else l = Val(s)
'
'    If l > Server(ServerIndex).BanDatabaseRecords Or l < 1 Then SendPM ServerIndex, UserID, "Ban number out of bounds": Exit Sub
'    If I = 0 Then
'     SendPM ServerIndex, UserID, l & ". " & GetBanDatabaseRecordField(ServerIndex, l, B_Comment)
'    Else
'     PutBanDatabaseRecordField ServerIndex, l, B_Comment, Mid(s, I + 1)
'     SendPM ServerIndex, UserID, "Comment for ban number " & l & " updated."
'    End If
   ElseIf Left(Command, 9) = "?scoreadd" Then
    If Not .AccountOp Then Exit Sub
    s = LTrim(Mid(Command, 10))
    I = InStr(s, ":")
    If I > 0 Then
     I2 = InStr(I + 1, s, ":")
     If I2 > 0 Then
      s2 = GetIPString(Left(s, I - 1))
      s3 = GetStringL(Val(Mid(s, I + 1, I2 - I - 1)))
      S4 = Mid(s, I2 + 1)
      L = GetUserDatabaseIndex(ServerIndex, S4, s3)
      If L = 0 Then
       CreateUserDatabaseRecord ServerIndex, L, S4, s2, s3
       AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") User Added to User Database by " & .Name & " (Biller AccountOp)"
       SendPM ServerIndex, UserID, L & ". " & S4 & " User Database record added"
      Else
       SendPM ServerIndex, UserID, "The record already exists. UserID:" & L
      End If
      Exit Sub
     End If
    End If
    SendPM ServerIndex, UserID, "Format: ?scoreadd (ip):(macid):(name)"
   ElseIf Left(Command, 10) = "?scoreedit" Then
    If Not .AccountOp Then Exit Sub
    s = LTrim(Mid(Command, 11))
    I = InStr(s, " ")
    If I > 0 Then
     I2 = InStr(I + 1, s, " ")
     If I2 > 0 Then
      I3 = InStr(I2 + 1, s, " ")
      If I3 > 0 Then
       I4 = InStr(I3 + 1, s, " ")
       If I4 > 0 Then
        I5 = InStr(I4 + 1, s, " ")
        If I5 > 0 Then
         L = Val(Left(s, I - 1))
         If L < 1 Or L > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
         For L2 = 1 To Server(ServerIndex).TotalUsers 'go thru logged in users
          If Server(ServerIndex).User(L2).UserDatabaseIndex = L Then 'trying to edit score of logged in player
           SendPM ServerIndex, UserID, L & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name)) & " Must log off first."
           Exit Sub
          End If
         Next
         PutScoreDatabaseRecord ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)), GetStringI(Mid(s, I + 1, I2 - I - 1)) & GetStringI(Mid(s, I2 + 1, I3 - I2 - 1)) & GetStringI(Mid(s, I3 + 1, I4 - I3 - 1)) & GetStringL(Mid(s, I4 + 1, I5 - I4 - 1)) & GetStringL(Mid(s, I5 + 1))
         AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") Score data modified to User Database by " & .Name & " (Biller AccountOp)"
         SendPM ServerIndex, UserID, L & ". Score data changed"
         Exit Sub
        End If
       End If
      End If
     End If
    End If
    SendPM ServerIndex, UserID, "Format: ?scoreedit (UserID) (Win) (Loss) (Ratio) (KillPoints) (FlagPoints)"
   ElseIf Left(Command, 12) = "?scoredelete" Then
    L = Val(Mid(Command, 13))
    If L < 1 Or L > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
    If Not .AccountOp Then 'can only delete your own
     If GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID)) <> .MacID Then
      SendPM ServerIndex, UserID, "User Database record is not yours."
      Exit Sub
     End If
    End If
    L4 = GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex))
    s2 = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
    SendPM ServerIndex, UserID, Space(Len(CStr(L))) + "  Name" + Space(L_Name - 4) + " Squad" + Space(LS_Name - 5) + " Win   Loss  Ratio KillPoints FlagPoints"
    S4 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name))
    s3 = GetScoreDatabaseRecord(ServerIndex, L4)
    SendPM ServerIndex, UserID, L & ". " & s2 & Space(L_Name - Len(s2)) & " " & S4 & Space(LS_Name - Len(S4)) & " " & GetInteger(Left(s3, 2)) & Space(5 - Len(CStr(GetInteger(Left(s3, 2))))) & " " & GetInteger(Mid(s3, 3, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s3, 3, 2))))) & " " & GetInteger(Mid(s3, 5, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s3, 5, 2))))) & " " & GetLong(Mid(s3, 7, 4)) & Space(10 - Len(CStr(GetLong(Mid(s3, 7, 4))))) & " " & GetLong(Mid(s3, 11, 4))
    For L2 = L + 1 To Server(ServerIndex).UserDatabaseRecords
     For L3 = 1 To Server(ServerIndex).TotalUsers
      If Server(ServerIndex).User(L3).UserDatabaseIndex = L2 Then Server(ServerIndex).User(L3).UserDatabaseIndex = L2 - 1 'this biller allows more than 1 user with same name and macid to login in
      If Server(ServerIndex).User(L3).UserDatabaseIndex = L Then '2 players with same macid&name can be logged in
       Server(ServerIndex).User(L3).UserDatabaseIndex = 0 'so when "user exited" packet is received, no User Database record will be touched
       'SendPM ServerIndex, Server(ServerIndex).User(L3).UserID, "Goodbye"
       SendPM ServerIndex, Server(ServerIndex).User(L3).UserID, L & ". " & s2 & " Your current User Database record has been deleted by " & .Name
       'unremark for player to get kicked if deleted record. in continuum player is supposed to get the No Data message but instead it reenters the arena and just keeps stuck there
       'UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(2) + GetStringL(Server(ServerIndex).User(L3).UserID) 'connection dissalowed
      End If
     Next
     L5 = GetLong(GetUserDatabaseRecordField(ServerIndex, L2, U_ScoreIndex))
     For L3 = L4 + 1 To Server(ServerIndex).ScoreDatabaseRecords
      If L3 = L5 Then PutUserDatabaseRecordField ServerIndex, L2, U_ScoreIndex, GetStringL(L3 - 1)
     Next
    Next
    With Server(ServerIndex)
    .UserDatabase = Left(.UserDatabase, (L - 1) * U_Length) + Mid(.UserDatabase, L * U_Length + 1)
    .UserDatabaseRecords = .UserDatabaseRecords - 1
    .ScoreDatabase = Left(.ScoreDatabase, (L4 - 1) * L_Score) + Mid(.ScoreDatabase, L4 * L_Score + 1)
    .ScoreDatabaseRecords = .ScoreDatabaseRecords - 1
    End With
    SendPM ServerIndex, UserID, "User Database record is successfully deleted."
    AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") User record deleted from User Database by " & .Name
'didn't work
'   ElseIf Left(Command, 7) = "?alogin" Then
'    s = LCase(LTrim(Mid(Command, 8)))
'    For l = 1 To Server(ServerIndex).UserDatabaseRecords
'     If GetLong(GetUserDatabaseRecordField(ServerIndex, l, U_MacID)) = .MacID Then
'      s2 = GetUserDatabaseRecordField(ServerIndex, l, U_Name)
'      If LCase(TrimZero(s2)) = s Then
''      unremark so player would get kicked if deleted own record. in continuum player is supposed to get the No Data message but instead it reenters the arena and just keeps stuck there
'       UDPSend TempSock, Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(2) + Mid(Message, 8, 4) 'connection dissalowed
'
'    s3 = Chr(0) + Chr(3) + MessagesSentCount(ServerIndex) + Chr(1) + Chr(0) + Mid(Message, 8, 4)
'    s3 = s3 + s2 + FillZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, l, U_SquadIndex)), S_Name), LS_Name) + GetUserDatabaseRecordField(ServerIndex, l, U_Banner)
'    s3 = s3 + GetUserDatabaseRecordField(ServerIndex, l, U_TotalSeconds) + GetUserDatabaseRecordField(ServerIndex, l, U_CreateDateTime)
'    s3 = s3 + String(4, Chr(0)) + GetStringL(l) + String(4, Chr(0)) + GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, l, U_ScoreIndex)))
'    UDPSend TempSock, s3
'
'       Exit Sub
'      End If
'     End If
'    Next
'    If s = "" Then
'     SendPM ServerIndex, UserID, "Format: ?alogin (name)"
'    Else
'     SendPM ServerIndex, UserID, "User name is not yours or unknown in User Database."
'    End If
   ElseIf Left(Command, 9) = "?scoreall" Then
    SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords))) + "  Name" + Space(L_Name - 4) + " Squad" + Space(LS_Name - 5) + " Win   Loss  Ratio KillPoints FlagPoints TotalPoints"
    L2 = Val(Mid(Command, 10))
    If L2 = 0 Then L2 = 1
    For L = 1 + 40 * (L2 - 1) To 40 * (L2 - 1) + 40
     If L > Server(ServerIndex).UserDatabaseRecords Then Exit For
     s = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
     S4 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name))
     s2 = GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
     SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords)) - Len(CStr(L))) & L & ". " & s & Space(L_Name - Len(s)) & " " & S4 & Space(LS_Name - Len(S4)) & " " & GetInteger(Left(s2, 2)) & Space(5 - Len(CStr(GetInteger(Left(s2, 2))))) & " " & GetInteger(Mid(s2, 3, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 3, 2))))) & " " & GetInteger(Mid(s2, 5, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 5, 2))))) & " " & GetLong(Mid(s2, 7, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 7, 4))))) & " " & GetLong(Mid(s2, 11, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 11, 4))))) & " " & (GetLong(Mid(s2, 7, 4)) + GetLong(Mid(s2, 11, 4)))
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 10) = "?scorefind" Then
    s3 = LCase(LTrim(Mid(Command, 11)))
    I = InStr(s3, " ")
    If I > 0 Then
     S5 = Mid(s3, I + 1)
     If IsNumeric(Left(s3, I - 1)) And S5 > "" Then
      SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords))) + "  Name" + Space(L_Name - 4) + " Squad" + Space(LS_Name - 5) + " Win   Loss  Ratio KillPoints FlagPoints TotalPoints"
      L2 = Val(Left(s3, I - 1))
      If L2 = 0 Then L2 = 1
      L4 = 1
      For L = 1 To Server(ServerIndex).UserDatabaseRecords
       s = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
       If LCase(s) = S5 Then
        b = b + 1
        If b = 40 Then L4 = L4 + 1: b = 0
        If L4 = L2 Then
         S4 = TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name))
         s2 = GetScoreDatabaseRecord(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_ScoreIndex)))
         SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords)) - Len(CStr(L))) & L & ". " & s & Space(L_Name - Len(s)) & " " & S4 & Space(LS_Name - Len(S4)) & " " & GetInteger(Left(s2, 2)) & Space(5 - Len(CStr(GetInteger(Left(s2, 2))))) & " " & GetInteger(Mid(s2, 3, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 3, 2))))) & " " & GetInteger(Mid(s2, 5, 2)) & Space(5 - Len(CStr(GetInteger(Mid(s2, 5, 2))))) & " " & GetLong(Mid(s2, 7, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 7, 4))))) & " " & GetLong(Mid(s2, 11, 4)) & Space(10 - Len(CStr(GetLong(Mid(s2, 11, 4))))) & " " & (GetLong(Mid(s2, 7, 4)) + GetLong(Mid(s2, 11, 4)))
        End If
        If L4 > L2 Then Exit For
       End If
      Next
      SendPM ServerIndex, UserID, "Page " & L2
      Exit Sub
     End If
    End If
    SendPM ServerIndex, UserID, "Format: ?scorefind (page) (name)"
   ElseIf Command = "?version" Then
    SendPM ServerIndex, UserID, App.Title & App.Major & " (SGS Biller)" & " Date " + Format(FileDateTime(App.EXEName & ".exe"), "mm/dd/yyyy") + " Size " & FileLen(App.EXEName & ".exe") & "B  Made in Visual Basic 5 by DuckDuck"
   ElseIf Command = "?about" Then
    SendPM ServerIndex, UserID, "A biller is a program that connects to a game server to save/keep players' scores, names, squads, ids, and other related information."
   ElseIf Command = "?misc" Then
    SendPM ServerIndex, UserID, "Helpfull Information"
    SendPM ServerIndex, UserID, "To update your score to Top10 you must reenter zone. Top10 will also update when you win a flag game."
    SendPM ServerIndex, UserID, "Scores are received by biller only when their total is greater than 5 points."
    SendPM ServerIndex, UserID, "When you type ?UserId, you'll get the index of your record in User Database."
    SendPM ServerIndex, UserID, "When no one owns a squad, you can grant it to yourself. Public squads are squads without a password."
    SendPM ServerIndex, UserID, "When you dissolve your squad, all the members that were in it leave it."
   ElseIf Command = "?bhelp" Then
    SendPM ServerIndex, UserID, "Player Database (Biller) Commands"
    SendPM ServerIndex, UserID, "?version - Display biller version information.......................Public Status"
    SendPM ServerIndex, UserID, "?about - Tells what a biller is"
    SendPM ServerIndex, UserID, "?misc - Helpfull information"
    If Not .SysOp Then SendPM ServerIndex, UserID, "?find (name) - Find a player on the biller network"
    SendPM ServerIndex, UserID, "?chat (channel(s)) - Set/show chat channels separated by commas"
'    SendPM ServerIndex, UserID, "?chati (number) (new channel) - Insert a new channel in existing channel list"
'    SendPM ServerIndex, UserID, "?chatd (number) - Delete a channel from the list"
    SendPM ServerIndex, UserID, "?zonelist (page) - List all servers connected to this biller"
    SendPM ServerIndex, UserID, "?zoneplayers (ZoneID) (page) - List players of a local zone"
    SendPM ServerIndex, UserID, "?squadjoin (name):(password) - Join an existing squad"
    SendPM ServerIndex, UserID, "?squadcreate (name):(password) - Create a new squad"
    SendPM ServerIndex, UserID, "?squadpassword (SquadID):(new password) - Change squad's password"
    SendPM ServerIndex, UserID, "?squadmembers (page) (squad name) - List all members of a squad"
    SendPM ServerIndex, UserID, "?squadgrant (UserID) - Pass squad ownership to given player"
    SendPM ServerIndex, UserID, "?squadleave - Leave the squad you are currently in"
    SendPM ServerIndex, UserID, "?squaddissolve (SquadID) - Dissolve your squad"
    SendPM ServerIndex, UserID, "?squadkick (UserID) - Remove a player from your squad"
    SendPM ServerIndex, UserID, "?squaddatabase (page) - Show the Squad Database"
    SendPM ServerIndex, UserID, "?squadown (page) - Show squads you own"
    SendPM ServerIndex, UserID, "?squadname (SquadID):(new name) - Change squad's name if you are owner or AccountOp"
    SendPM ServerIndex, UserID, "?squadid - Shows your SquadID if you are in a squad"
    SendPM ServerIndex, UserID, "?scoreall (page) - Show scores of all users"
    SendPM ServerIndex, UserID, "?scoreown (page) - Show scores of all your names"
    SendPM ServerIndex, UserID, "?scoreswap (other name) - Swap scores of your current name with your other name"
    SendPM ServerIndex, UserID, "?scoredelete (UserID) - Delete a player record from User Database"
    SendPM ServerIndex, UserID, "?scorefind (page) (name) - Get UserID of players with matching name"
    SendPM ServerIndex, UserID, "?scoreid - Shows your ScoreID"
    SendPM ServerIndex, UserID, "?top10 (win/loss/ratio/kill/flag/total) - Show the Top 10. ?top20 will show Top 20 and so on."
    SendPM ServerIndex, UserID, "?listop (page) - Display logged in biller operators"
'can't make work
'    SendPM ServerIndex, UserID, "?alogin (name) - Relogin with your other name"
    SendPM ServerIndex, UserID, "?login (password(s)) - Gain biller MessageOp/AccountOp/SysOp status"
    SendPM ServerIndex, UserID, "?logoff (M/A/S) - Drop biller MessageOp/AccountOp/SysOp status"
    If .MessageOp Then
     SendPM ServerIndex, UserID, "**(message) - Send an arena message to all connected zones..........MessageOp Status"
    End If
    If .AccountOp Then
     SendPM ServerIndex, UserID, "?username (UserID):(new name) - Change a player's name..............AccountOp Status"
     SendPM ServerIndex, UserID, "?squadowner (SquadID):(new UserID) - Change a squad's owner"
     SendPM ServerIndex, UserID, "?scoreadd (ip):(macid):(name) - Create a new User Database record"
     SendPM ServerIndex, UserID, "?scoreedit (UserID) (W) (L) (R) (KP) (FP) - Edit a User Database record"
'     SendPM ServerIndex, UserID, "?useridmove (UserID:new id) - Move a player to a new UserID position"
    End If
    If .SysOp Then
     SendPM ServerIndex, UserID, "?find (name/macid/ip) - Search for a player using name/macid/ip"
     SendPM ServerIndex, UserID, "?info (name) - Display stored player information"
     SendPM ServerIndex, UserID, "?infopage (page) (name) - Display stored player information by page"
     SendPM ServerIndex, UserID, "?infodump (page) - Display all players' info"
     SendPM ServerIndex, UserID, "?alias (macid) - Display all other names a player has"
     SendPM ServerIndex, UserID, "?aliaspage (page) (macid) - Display by page other names a player has"
     SendPM ServerIndex, UserID, "?aliasx2 (page) - Display aliases of only players that have used more than 1"
     SendPM ServerIndex, UserID, "?bget (section):(key) - Read a setting in biller's settings file....SysOp Status"
     SendPM ServerIndex, UserID, "?bset (section):(key):(value) - Write setting in biller's settings file"
     SendPM ServerIndex, UserID, "?zonerecycle (ZoneID) - Recycle a zone"
     SendPM ServerIndex, UserID, "?zonereset (ZoneID) - Executes a single-zone scorereset"
     SendPM ServerIndex, UserID, "?zoneclose (ZoneID) - Shuts down a zone"
     SendPM ServerIndex, UserID, "?listoppassword - Shows MessageOp/AccountOp/SysOp passwords"
     SendPM ServerIndex, UserID, "?greeting (default/custom/off) - Change greeting to players who log in"
     SendPM ServerIndex, UserID, "?save - Save databases to disk of all zones connected to this biller"
     SendPM ServerIndex, UserID, "?autosave (hh:mm:ss) - Change periodic save time of the databases"
    End If
   ElseIf Command = "?listoppassword" Then
    If Not .SysOp Then Exit Sub
    SendPM ServerIndex, UserID, "MessageOpPassword: " + GetProfile("Passwords", "MessageOpPassword")
    SendPM ServerIndex, UserID, "AccountOpPassword: " + GetProfile("Passwords", "AccountOpPassword")
    SendPM ServerIndex, UserID, "SysOpPassword: " + GetProfile("Passwords", "SysOpPassword")
   ElseIf Left(Command, 7) = "?listop" Then
    L4 = Val(Mid(Command, 8))
    If L4 = 0 Then L4 = 1
    L3 = 1
    For L = 1 To TotalServers
     For L2 = 1 To Server(L).TotalUsers
      s = ""
      If Server(L).User(L2).MessageOp Then s = s + "MessageOp/"
      If Server(L).User(L2).AccountOp Then s = s + "AccountOp/"
      If Server(L).User(L2).SysOp Then s = s + "SysOp/"
      If s > "" Then
       b = b + 1 'counting lines
       If b = 40 Then L3 = L3 + 1: b = 0 'gonna start next page
       If L3 = L4 Then SendPM ServerIndex, UserID, Server(L).User(L2).Name + " [" + Left(s, Len(s) - 1) + "] in " + Server(L).Name
       If L3 > L4 Then GoTo listopbypagedone
      End If
     Next
    Next
listopbypagedone:
    SendPM ServerIndex, UserID, "Page " & L4
   ElseIf Left(Command, 6) = "?login" Then
    If InStr(Mid(Command, 7), GetProfile("Passwords", "MessageOpPassword")) > 0 Then .MessageOp = 1
    If InStr(Mid(Command, 7), GetProfile("Passwords", "AccountOpPassword")) > 0 Then .AccountOp = 1
    If InStr(Mid(Command, 7), GetProfile("Passwords", "SysOpPassword")) > 0 Then .SysOp = 1
    If .MessageOp Then s = s + "MessageOp/"
    If .AccountOp Then s = s + "AccountOp/"
    If .SysOp Then s = s + "SysOp/"
    If s > "" Then SendPM ServerIndex, UserID, "Logged into " + App.Title + " as " + Left(s, Len(s) - 1)
   ElseIf Left(Command, 7) = "?logoff" Then
    s = LCase(Mid(Command, 8))
    If InStr(s, "m") > 0 And .MessageOp Then .MessageOp = 0: s2 = s2 + "MessageOp/"
    If InStr(s, "a") > 0 And .AccountOp Then .AccountOp = 0: s2 = s2 + "AccountOp/"
    If InStr(s, "s") > 0 And .SysOp Then .SysOp = 0: s2 = s2 + "SysOp/"
    If s2 > "" Then SendPM ServerIndex, UserID, "Biller operator status dropped: " & Left(s2, Len(s2) - 1)
   ElseIf Left(Command, 5) = "?bset" Then
    If Not .SysOp Then Exit Sub
    s = LTrim(Mid(Command, 6))
    I = InStr(s, ":")
    If I > 0 Then
     I2 = InStr(I + 1, s, ":")
     If I2 > 0 Then
      s2 = Left(s, I - 1)
      s3 = Mid(s, I + 1, I2 - I - 1)
      S4 = Mid(s, I2 + 1)
      SetProfile s2, s3, S4
      SendPM ServerIndex, UserID, s2 + ":" + s3 + ":" + GetProfile(s2, s3)
      Exit Sub
     End If
    End If
    SendPM ServerIndex, UserID, "Format: ?bset (section):(key):(value)"
   ElseIf Left(Command, 5) = "?bget" Then
    If Not .SysOp Then Exit Sub
    s = LTrim(Mid(Command, 6))
    I = InStr(s, ":")
    If I > 0 Then
     s2 = Left(s, I - 1)
     s3 = Mid(s, I + 1)
     SendPM ServerIndex, UserID, s2 + ":" + s3 + ":" + GetProfile(s2, s3)
     Exit Sub
    End If
    SendPM ServerIndex, UserID, "Format: ?bget (section):(key)"
   ElseIf Left(Command, 9) = "?zonelist" Then
    SendPM ServerIndex, UserID, App.Title & " Network (" & TotalServers & " game servers)"
    L2 = Val(Mid(Command, 10))
    If L2 = 0 Then L2 = 1
    For L = 1 + 40 * (L2 - 1) To 40 * (L2 - 1) + 40
     If L > TotalServers Then Exit For
     s = ""
     If .SysOp Then s = " " & GetIPFormat(GetStringL(Server(L).Sock.sin_addr)) & ":" & Server(L).Port & " MSC:" & Server(L).MessagesSentCount
     SendPM ServerIndex, UserID, Space(Len(CStr(TotalServers)) - Len(CStr(L))) & L & ". " & Server(L).Name & s & " User Database ID:" & Server(L).ServerID & " Squad Database ID:" & Server(L).GroupID & " Score Database ID:" & Server(L).ScoreID & " [" & Server(L).TotalUsers & " players]"
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 12) = "?zoneplayers" Then
    s = LTrim(Mid(Command, 13))
    I = InStr(s, " ")
    If I > 0 Then
     L = Val(Left(s, I - 1))
     L2 = Val(Mid(s, I + 1))
    ElseIf IsNumeric(s) Then
     L = Val(s)
    Else
     L = ServerIndex
    End If
    If L2 = 0 Then L2 = 1
    If L < 1 Or L > TotalServers Then SendPM ServerIndex, UserID, "ZoneID is out of bounds": Exit Sub
    SendPM ServerIndex, UserID, Server(L).Name + " (" & Server(L).TotalUsers & " players) (User Database ID:" & Server(L).ServerID & " Squad Database ID:" & Server(L).GroupID & " Score Database ID:" & Server(L).ScoreID & ")"
    For L3 = 1 + 40 * (L2 - 1) To 40 * (L2 - 1) + 40 Step 3
     If L3 > Server(L).TotalUsers Then Exit For
     s = ""
     If L3 <= Server(L).TotalUsers Then s = Server(L).User(L3).Name
     s2 = ""
     If L3 + 1 <= Server(L).TotalUsers Then s2 = Space(L_Name - Len(s)) + " " + Server(L).User(L3 + 1).Name
     s3 = ""
     If L3 + 2 <= Server(L).TotalUsers Then s3 = Space(L_Name - Len(Server(L).User(L3 + 1).Name)) + " " + Server(L).User(L3 + 2).Name
     SendPM ServerIndex, UserID, s + s2 + s3
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 12) = "?zonerecycle" Then
    If Not .SysOp Then Exit Sub
    L = Val(Mid(Command, 13))
    If L < 1 Or L > TotalServers Then SendPM ServerIndex, UserID, "ZoneID is out of bounds": Exit Sub
    AddTerminal Server(L).Name + "(ServerID:" & Server(L).ServerID & " GroupID:" & Server(L).GroupID & " ScoreID:" & Server(L).ScoreID & ") Recycled by " + .Name + "(Biller SysOp)"
    SendPM ServerIndex, UserID, Server(L).Name + " recycled."
    UDPSend Server(L).Sock, Chr(0) + Chr(3) + MessagesSentCount(L) + Chr(4) + Chr(0) + Chr(1) + Chr(0) + Chr(0) + Chr(0) + Chr(2) + Chr(0) + Chr(0) + Chr(0)
   ElseIf Left(Command, 10) = "?zonereset" Then
    If Not .SysOp Then Exit Sub
    L = Val(Mid(Command, 11))
    If L < 1 Or L > TotalServers Then SendPM ServerIndex, UserID, "ZoneID is out of bounds": Exit Sub
    For L2 = 1 To Server(L).UserDatabaseRecords
     PutScoreDatabaseRecord L, GetLong(GetUserDatabaseRecordField(ServerIndex, L2, U_ScoreIndex)), String(L_Score, Chr(0))
    Next
    AddTerminal Server(L).Name + "(ServerID:" & Server(L).ServerID & " GroupID:" & Server(L).GroupID & " ScoreID:" & Server(L).ScoreID & ") Recycled and Reset by " + .Name + "(Biller SysOp)"
    SendPM ServerIndex, UserID, Server(L).Name + " recycled and reset."
    UDPSend Server(L).Sock, Chr(0) + Chr(3) + MessagesSentCount(L) + Chr(4) + Chr(0) + Chr(1) + Chr(0) + Chr(0) + Chr(0) + Chr(2) + Chr(0) + Chr(0) + Chr(0)
   ElseIf Left(Command, 10) = "?zoneclose" Then
    If Not .SysOp Then Exit Sub
    L = Val(Mid(Command, 11))
    If L < 1 Or L > TotalServers Then SendPM ServerIndex, UserID, "ZoneID is out of bounds": Exit Sub
    SendPM ServerIndex, UserID, Server(L).Name + " shutdown."
    AddTerminal Server(L).Name + "(ServerID:" & Server(L).ServerID & " GroupID:" & Server(L).GroupID & " ScoreID:" & Server(L).ScoreID & ") Shutdown by " + .Name + "(Biller SysOp)"
    UDPSend Server(L).Sock, Chr(0) + Chr(3) + MessagesSentCount(L) + Chr(2) + Chr(0) + Chr(1) + Chr(0) + Chr(0) + Chr(0) + Chr(2) + Chr(0) + Chr(0) + Chr(0)
   ElseIf Command = "?save" Then
    If Not .SysOp Then Exit Sub
    For L = 1 To TotalServers
     WriteDatabases L
    Next
    SendPM ServerIndex, UserID, "Databases are saved to disk"
   ElseIf Left(Command, 9) = "?autosave" Then
    s = LTrim(Mid(Command, 10))
    If s Like "##:##:##" And .SysOp Then
     AutoSave = s
     SendPM ServerIndex, UserID, "AutoSave is set to " & AutoSave
    Else
     SendPM ServerIndex, UserID, "Format: ?autosave (hh:mm:ss)  Current value: " & AutoSave
    End If
   ElseIf Left(Command, 9) = "?greeting" Then
    If Not .SysOp Then Exit Sub
    s = LTrim(Mid(Command, 10))
    If s = "default" Then
     Greeting = "[Default]"
     SendPM ServerIndex, UserID, "Greeting is set to default"
    ElseIf s = "off" Then
     Greeting = ""
     SendPM ServerIndex, UserID, "Greeting is disabled"
    ElseIf s > "" Then
     Greeting = s
     SendPM ServerIndex, UserID, "Greeting is set to custom"
    Else
     SendPM ServerIndex, UserID, "Format: ?greeting (custom/default/off)  Current: " + IIf(Greeting = "", "Off", Greeting)
    End If
   ElseIf Left(Command, 9) = "?username" Then
    If Not .AccountOp Then Exit Sub
    s = LTrim(Mid(Command, 10))
    I = InStr(s, ":")
    L = Val(s)
    If I > 0 Then
     L = Val(Left(s, I - 1))
    End If
    If L < 1 Or L > Server(ServerIndex).UserDatabaseRecords Then SendPM ServerIndex, UserID, "UserID is out of bounds": Exit Sub
    If I > 0 Then
     PutUserDatabaseRecordField ServerIndex, L, U_Name, Mid(s, I + 1)
     SendPM ServerIndex, UserID, "Player name updated to User Database."
    Else
     SendPM ServerIndex, UserID, L & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
    End If
   ElseIf Left(Command, 9) = "?infodump" Then
    If Not .SysOp Then Exit Sub
    L2 = Val(Mid(Command, 10))
    If L2 = 0 Then L2 = 1
    For L = 1 + 40 * (L2 - 1) To 40 * (L2 - 1) + 40
     If L > Server(ServerIndex).UserDatabaseRecords Then Exit For
     SendPM ServerIndex, UserID, Space(Len(CStr(Server(ServerIndex).UserDatabaseRecords)) - Len(CStr(L))) & L & ". " & TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name)) & " Squad:" & TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name)) & " LastDatePlayed:" + GetDateFormat(GetUserDatabaseRecordField(ServerIndex, L, U_LastDatePlayed)) + " IP:" + GetIPFormat(GetUserDatabaseRecordField(ServerIndex, L, U_IP)) + " MacID:" & GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID))
    Next
    SendPM ServerIndex, UserID, "Page " & L2
   ElseIf Left(Command, 9) = "?infopage" Then
    If Not .SysOp Then Exit Sub
    s = LCase(LTrim(Mid(Command, 10)))
    I = InStr(s, " ")
    If I > 0 Then
     L2 = Val(Left(s, I - 1))
     If L2 = 0 Then L2 = 1
     L4 = 1
     s = LTrim(Mid(s, I + 1))
     For L = 1 To Server(ServerIndex).UserDatabaseRecords
      s2 = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
      If LCase(s2) = s Then
       b = b + 1
       If b = 40 Then L4 = L4 + 1: b = 0
       If L4 = L2 Then SendPM ServerIndex, UserID, L & ". " & s2 & " Squad:" & TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name)) & " LastDatePlayed:" + GetDateFormat(GetUserDatabaseRecordField(ServerIndex, L, U_LastDatePlayed)) + " IP:" + GetIPFormat(GetUserDatabaseRecordField(ServerIndex, L, U_IP)) + " MacID:" & GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID))
       If L4 > L2 Then Exit For
      End If
     Next
     SendPM ServerIndex, UserID, "Page " & L2
    Else
     SendPM ServerIndex, UserID, "Format: ?infopage (page) (name)"
    End If
   ElseIf Left(Command, 5) = "?info" Then
    If Not .SysOp Then Exit Sub
    s = LCase(LTrim(Mid(Command, 6)))
    If s = "" Then
     SendPM ServerIndex, UserID, "Format: ?info (name)"
    Else
     For L = 1 To Server(ServerIndex).UserDatabaseRecords
      s2 = TrimZero(GetUserDatabaseRecordField(ServerIndex, L, U_Name))
      If LCase(s2) = s Then SendPM ServerIndex, UserID, L & ". " & s2 & " Squad:" & TrimZero(GetSquadDatabaseRecordField(ServerIndex, GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_SquadIndex)), S_Name)) & " LastDatePlayed:" + GetDateFormat(GetUserDatabaseRecordField(ServerIndex, L, U_LastDatePlayed)) + " IP:" + GetIPFormat(GetUserDatabaseRecordField(ServerIndex, L, U_IP)) + " MacID:" & GetLong(GetUserDatabaseRecordField(ServerIndex, L, U_MacID))
     Next
    End If
   ElseIf Left(Command, 8) = "?aliasx2" Then
    If Not .SysOp Then Exit Sub
    s = GetAliasesX2(ServerIndex)
    If s > "" Then
     L2 = Val(Mid(Command, 9))
     If L2 = 0 Then L2 = 1
     s = "Players with more than 1 alias: " + s
     For L = 1 + 40 * (L2 - 1) * 70 To 40 * (L2 - 1) * 70 + 40 * 70 Step 70
      s2 = Mid(s, L, 70): If s2 = "" Then Exit For
      SendPM ServerIndex, UserID, s2
     Next
     SendPM ServerIndex, UserID, "Page " & L2
    Else
     SendPM ServerIndex, UserID, "There are no players that have used more than 1 alias."
    End If
   ElseIf Left(Command, 10) = "?aliaspage" Then
    If Not .SysOp Then Exit Sub
    s = LTrim(Mid(Command, 11))
    I = InStr(s, " ")
    If I > 0 Then
     L2 = Val(Left(s, I - 1))
     If L2 = 0 Then L2 = 1
     L3 = Val(Mid(s, I + 1))
     s2 = GetAliases(ServerIndex, L3)
     If s2 > "" Then
      s2 = "Aliases of " & L3 & ": " & s2
      For L = 1 + 40 * (L2 - 1) * 70 To 40 * (L2 - 1) * 70 + 40 * 70 Step 70
       s3 = Mid(s2, L, 70): If s3 = "" Then Exit For
       SendPM ServerIndex, UserID, s3
      Next
      SendPM ServerIndex, UserID, "Page " & L2
     Else
      GoTo foundnoaliases
     End If
    ElseIf IsNumeric(s) Then
     L3 = Val(s)
     GoTo getjustalias
    Else
     SendPM ServerIndex, UserID, "Format: ?aliaspage (page) (macid)"
    End If
   ElseIf Left(Command, 6) = "?alias" Then
    If Not .SysOp Then Exit Sub
    L3 = Val(Mid(Command, 7))
getjustalias:
    s2 = GetAliases(ServerIndex, L3)
    If s2 > "" Then
     s2 = "Aliases of " & L3 & ": " & s2
     For L = 1 To Len(s2) Step 70
      SendPM ServerIndex, UserID, Mid(s2, L, 70)
     Next
    Else
foundnoaliases:
     SendPM ServerIndex, UserID, "Player has not used any other aliases."
    End If
   End If
   End With
  Case Else
   'Dunno what this user-related packet does yet
   AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") Unknown user event " & Asc(Mid(Message, 7, 1))
   ChDrive App.Path: ChDir App.Path
   Open "unknownuserevent." & Asc(Mid(Message, 7, 1)) For Append As #1
    Print #1, Date; Time; Message
   Close 1
  End Select
 Case Chr(0) + Chr(4) 'Game Server ACKed something of mine, just ignore for now
 Case Chr(0) + Chr(7) 'Game Server shutdown/recycled
  AddTerminal "Disconnecting " & GetIPFormat(GetStringL(TempSock.sin_addr)) & ":" & Server(ServerIndex).Port
  AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") Game server logging off"
  LogoffServer ServerIndex
 Case Else
  'I dunno what it does, so simply ACK it
  UDPSend TempSock, Chr(0) + Chr(4) + Mid(Message, 3, 4)
  AddTerminal Server(ServerIndex).Name + "(ServerID:" & Server(ServerIndex).ServerID & " GroupID:" & Server(ServerIndex).GroupID & " ScoreID:" & Server(ServerIndex).ScoreID & ") Unrecognized connection event " & Asc(Mid(Message, 2, 1))
  ChDrive App.Path: ChDir App.Path
  Open "unknownconnectionevent." & Asc(Mid(Message, 2, 1)) For Append As #1
   Print #1, Date; Time; Message
  Close 1
 End Select
End If
Exit Sub

ErrHandler:
AddTerminal Err.Description & " " & Err
Resume Next
End Sub

'Load the overhead
Public Sub UDPStartWinsock()
WSAStartup 257&, WSAdata
'WinsockWindow = CreateWindowEx(0, "#32770", app.title & " - Winsock Stack Capture", 0&, 0, 0, 1, 1, 0&, 0&, App.hInstance, 0&)
WinsockWindow = frmTerminal.hWnd 'use our frmTerminal window instead
OldWinsockWindow = SetWindowLongA(WinsockWindow, GWL_WNDPROC, AddressOf WindowProc)
End Sub

'Unload the overhead
Public Sub UDPEndWinsock()
SetWindowLongA WinsockWindow, GWL_WNDPROC, OldWinsockWindow
'DestroyWindow WinsockWindow
WSACleanup
End Sub

'Send the message to the given IP/Port of one of a zone connected to our biller
Public Sub UDPSend(TempSock As sockaddrTYPES, Message As String)
sendto SockID, ByVal Message, Len(Message), 0&, TempSock, 16&
End Sub

'The CallBack
Public Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim mStr As String * 520, mLen As Integer

If uMsg = 5150 Then
 mLen = recvfrom(wParam, ByVal mStr, 520&, 0&, Sock, 16&)
 If mLen > 0 Then OnRecv Sock, Left(mStr, mLen)
Else
 WindowProc = CallWindowProcA(OldWinsockWindow, hWnd, uMsg, wParam, ByVal lParam)
End If
End Function
